<template>
    <div>
        <div class="wrapper" v-if="isAuthenticated && ['login', 'password.request', 'password.reset'].indexOf($route.name) === -1">
            <!-- Navbar -->
            <navbar ref="navbar"></navbar>
            <!-- Sidebar -->
            <sidebar></sidebar>

            <transition name="fade" mode="out-in" appear>
                <router-view v-if="error === null"></router-view>
                <access-denied v-else-if="error.status === 403" v-bind:error="error"/>
                <not-found v-else-if="error.status === 404" v-bind:error="error"/>
                <internal-server-error v-else-if="error.status === 500" v-bind:error="error"/>
            </transition>
            
            <!-- Main Footer -->
            <footer class="main-footer">
                <!-- Default to the left -->
                Base
            </footer>
            <!-- Modal del perfil del usuario -->
            <b-modal id="profile-modal" ref="profileModal" title="Editar perfil" ok-only 
                     v-bind:static="true">
                <user-form ref="profileForm"></user-form>
                <div slot="modal-footer" class="w-100">
                    <b-button variant="primary" class="float-right" @click="saveUser">
                        Guardar
                    </b-button>
                </div>
            </b-modal>
        </div>
        <router-view v-else></router-view>
    </div>
</template>

<script>
import Sidebar from './Sidebar.vue';
import Navbar from './Navbar.vue';
import auth from '../auth.js';
import utils from '../utils.js';
import UserForm from '../views/users/Form.vue';
import AccessDenied from '../views/errors/403.vue';
import NotFound from '../views/errors/404.vue';
import InternalServerError from '../views/errors/500.vue';

const _ = import('lodash');

export default {
    components: {
        'sidebar': Sidebar,
        'navbar': Navbar,
        'user-form': UserForm,
        'access-denied': AccessDenied,
        'not-found': NotFound,
        'internal-server-error': InternalServerError
    },
    data() {
        return {
            error: null,
            isAuthenticated: auth.loggedIn()
        };
    },
    methods: {
        editProfile() {
            var user = auth.user();
            if (user === null) {
                return;
            }
            this.$refs.profileForm.setMode('profile');
            this.$refs.profileForm.setData(user);
            this.$refs.profileForm.resetErrors();
            this.$refs.profileModal.show();
        },
        saveUser() {
            var vm = this;
            $(this.$refs.profileModal.$el).find('.modal-content').busyLoad('show', {
                background: 'rgba(255, 255, 255, 0.7)',
                color: '#000000'
            });
            this.$refs.profileForm.saveModel(function(response) {
                // Actualizar datos del usuario
                let sessData = JSON.parse(localStorage.getItem('session_data'));
                sessData.user = response.data.data;
                localStorage.setItem('session_data', JSON.stringify(sessData));
                vm.$refs.navbar.setUser(response.data.data);
                // Cerrar modal
                vm.$refs.profileModal.hide();
            }, function() {
                $(vm.$refs.profileModal.$el).find('.modal-content').busyLoad('hide');
            }, function() {
                $(vm.$refs.profileModal.$el).find('.modal-content').busyLoad('hide');
            });
        }
    }
};
</script>